
import numpy as np
import cv2
from matplotlib import pyplot as plt

#
#   FUNCTIONS
#


class FileNotFoundError(OSError):
    pass

def collect_coordinates(image_file_name, yes_color, no_color):
    """collects coordinates of all pixels with value yes_color in yes_coords
    and no_color in no_coordinates, respectively"""
    image = cv2.imread(image_file_name)
    if image is None:
        raise FileNotFoundError(image_file_name)
    yes_coords = []
    no_coords = []
    (h, w)=image.shape[:2]
    for x in range(h):
        for y in range(w):
            if (image[x, y] == yes_color).all():
                yes_coords.append((x, y)) # markup for positive class (ant) sample pixels
            elif (image[x, y] == no_color).all():
                no_coords.append((x, y)) # markup for negative class (background) sample pixels
    return (yes_coords, no_coords)


#
#   ECEC
#

def extract_markup():
    print "EXTRACTING MARKUP"
    image = cv2.imread('classifier_imgs/frame 466 markup.png')

    image_orig = cv2.imread('classifier_imgs/frame 466 original.png')

    yes_color = (0, 0, 255)  # red markup for positive class samples

    no_color = (0, 255, 0)  # green markup for negative class samples (background)

    filename = 'classifier_imgs/frame 446'
