from Draw_Paths_stripped import *
from extract_frames import *
import csv

"""
Begins tracking of ants.
"""


# Imports csv list of video filen ames and paths..
VID_LIST_CSV = 'your_video_list'


vid_list = []
running_results = []


def track_one_exp(file_path, time, crop_coords, exp_nr, rotate_flag):
    """
    starts tracking of ants in a single 30sec video segment
    """
    print 'beginning tracking experiment ' + str(exp_nr) + ', video ' + file_path + ' at second ' + str(time)

    # select duration of tracking
    track_duration = 720  # 720 frames in 30 sec snippet

    # extract images
    extract_frames(time, track_duration, file_path, crop_coords, exp_nr, rotate_flag)

    # run feature calculation
    run_feature_calc()

    # extracting markup
    extract_markup()

    # run classifier
    run_classifier()

    # track ants
    start_tracking(track_duration)

    # draw frames
    results = start_drawing(exp_nr, time, track_duration)

    return results


def import_vid_list():
    """reads csv content and writes to list; returns list"""
    with open(VID_LIST_CSV, 'rb') as f:
        list = csv.reader(f, delimiter=',')
        for row in list:
            vid_list.append(row)
    return vid_list


def begin_bulk_tracking():
    """
    takes video name from list, pairs it with appropriate time, calls extractor
    """

    print "beginning tracking of all experiments"

    # gets list of all experiments to track
    import_vid_list()

    # times for extraction, in seconds of relative video duration
    extraction_times = [120, 139, 278]

    # centres of lower trail half for each experiment. For cropping.

    # 5x8 centres
    centres = [[1038, 564], [1034, 573], [1032, 645], [1026, 542], [1028, 646], [1033, 532], [1029, 585], [1028, 536],
               [1013, 539], [1023, 566], [1024, 715], [1023, 502], [1026, 573], [1015, 521], [1007, 579], [1017, 580],
               [1017, 579], [1017, 557], [1022, 576]]


    # sets cropping coordinates based on centre coords.
    crop_coords = [[centre[1] - 40, centre[1] + 60, centre[0] + 400, centre[0] + 550] for centre in centres]

    # indices of videos that require rotation
    indices_for_rotation = []

    for exp_nr in range(len(vid_list)):

        # handle rotation were needed
        if exp_nr in indices_for_rotation:
            print 'rotating this experiment'
            rotate_flag = True
        else:
            rotate_flag = False

        for time_iterator in range(3):

            # setting parameters
            vid_path = vid_list[exp_nr][1] + vid_list[exp_nr][time_iterator + 2]
            exp_time = extraction_times[time_iterator]
            exp_coords = crop_coords[exp_nr]

            # check if data already exists, and if so, skip
            dir = 'images/' + str(exp_nr) + '_' + str(exp_time) + '_tracked'

            if os.path.exists(dir):
                print 'experiment ', str(exp_nr), ' , video ' , exp_time, ' , already tracked; breaking'
                continue

            # tracking and recording measurement
            results = track_one_exp(vid_path, exp_time, exp_coords, exp_nr, rotate_flag)

            # building list of results for all experiments run in this isntance
            running_results.append((exp_nr, time_iterator, vid_path, results))

            current_result = []
            current_result.append((exp_nr, time_iterator, vid_path, results))

            # writing output to csv file
            writer(current_result)

            print 'running results, ignore unless errors occur ', running_results
    # print test_write



def writer(exp_measurement):
    """
    writes output of each 30sec measurement to CSV file
    :param exp_measurement: measurement of one 30sec experiment
    :return:
    """
    csv_out = open('tracking_results_30x8.csv', 'ab')
    my_writer = csv.writer(csv_out)
    my_writer.writerow(exp_measurement)

###
### EXECUTE
###

begin_bulk_tracking()


